<div class="pt-[4.5rem] md:pt-24 lg:pt-32 xl:pt-40">
  <!--Bloc image mobile-->
  <div class="w-full h-44 md:h-72 lg:h-96 xl:h-[38rem] relative lg:hidden">
    <div class="absolute inset-0 bg-cover bg-center" [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}">
    </div>

    <div class="absolute inset-0 flex items-end justify-end p-4">
      <button (click)="openGallery()" class="bg-white text-black px-4 py-2 text-sm rounded-full">
        Voir les photos <i class="fa-solid fa-camera ml-1"></i>
      </button>
    </div>
  </div>
  <!---->

  <div class="py-5 px-4">
    <div class="flex justify-center gap-5 items-center">
      <p class="text-center text-xl md:text-3xl lg:text-4xl">{{workshop?.workshop_name}}</p>
    </div>

    <div class="flex justify-center gap-2 items-center my-2">
      <app-star-rating [rating]="averageRating"></app-star-rating>
      <p class="font-medium">{{averageRating}}/5</p>
    </div>

    <div class="lg:flex justify-center gap-14 xl:gap-20 mt-5 items-center">
      <div class="flex gap-3 items-center mt-6 mb-4 lg:mt-0 lg:mb-0">
        <i class="fa-solid fa-location-dot text-xl"></i>
        <p>{{workshop?.workshop_address}}</p>
      </div>

      <div class="flex gap-3 items-center mb-4 lg:mb-0">
        <i class="fa-solid fa-comment"></i>
        <p>{{workshop?.reviews.length}} commentaires</p>
      </div>

      <div class="flex gap-3 items-center">
        <p>Par :</p>
        <p>{{workshop?.organizer?.merchant_name}}</p>
      </div>
    </div>

    <!--Bloc image desktop-->
    <div class="hidden lg:flex lg:gap-5 lg:justify-center lg:items-center lg:my-10 xl:mx-40">
      <!-- Rectangle Image -->
      <div class="relative w-1/2 h-96">
        <div class="absolute inset-0 bg-cover bg-center rounded"
          [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
      </div>

      <!-- Square Image -->
      <div class="relative w-1/3 h-96">
        <div class="absolute inset-0 bg-cover bg-center rounded"
          [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
      </div>

      <!-- Four Small Images -->
      <div class="grid grid-cols-2 grid-rows-2 gap-2 w-1/3 h-96 relative">
        <div class="relative w-full h-full">
          <div class="absolute inset-0 bg-cover bg-center rounded"
            [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
        </div>
        <div class="relative w-full h-full">
          <div class="absolute inset-0 bg-cover bg-center rounded"
            [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
        </div>
        <div class="relative w-full h-full">
          <div class="absolute inset-0 bg-cover bg-center rounded"
            [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
        </div>
        <div class="relative w-full h-full">
          <div class="absolute inset-0 bg-cover bg-center rounded"
            [ngStyle]="{'background-image': 'url(' + workshopImageUrl + ')'}"></div>
        </div>

        <div class="absolute inset-0 flex items-end justify-end p-4">
          <button (click)="openGallery()" class="bg-white text-black px-4 py-2 text-sm rounded-full">
            Voir les photos <i class="fa-solid fa-camera ml-1"></i>
          </button>
        </div>
      </div>
    </div>
    <!---->

    <div class="lg:flex justify-around gap-5 lg:flex-row-reverse xl:mx-40">
      <div class="bg-[#734124] text-white rounded-lg p-4 my-10 lg:w-1/3 lg:h-40">
        <p class="text-2xl font-medium">À partir de {{workshop?.workshop_price}} €</p>
        <p class="text-sm font-light italic">par personnes</p>
        <button (click)="openReservation()" class="w-full mt-5 py-3 bg-[#C29667] rounded-full">Réserver une date <i
            class="fa-solid fa-calendar ml-2"></i></button>
      </div>

      <div class="lg:w-1/2">
        <div class="my-5">
          <p class="text-lg lg:text-2xl lg:mb-3">Description de l’activité</p>
          <p class="text-sm font-light">{{workshop?.workshop_description}}</p>
        </div>

        <hr />

        <div class="my-5">
          <p class="text-lg lg:text-2xl">L'activité en détails</p>
          <div class="flex gap-3 items-center mt-3 mb-2">
            <i class="fa-solid fa-clock"></i>
            <p>{{workshop?.workshop_time}}</p>
          </div>

          <div class="flex gap-3 items-center mb-2">
            <i class="fa-solid fa-user-group"></i>
            <p>Jusqu'à {{workshop?.workshop_person}} personnes</p>
          </div>

          <div class="flex gap-3 items-center mb-5">
            <i class="fa-solid fa-user-check"></i>
            <p>{{workshop?.workshop_year}} ans minimum</p>
          </div>
        </div>

        <hr />

        @if(latitude && longitude){
        <div class="my-5">
          <p class="text-lg lg:text-2xl">Lieu de l’activité</p>
          <div class="flex gap-3 py-3">
            <i class="fa-solid fa-location-dot"></i>
            <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore
              magna aliqua.</p>
          </div>
          <div class="h-80 md:h-96 lg:h-[38rem] xl:h-[38rem] py-3">
            <app-leaflet-map [latitude]="latitude" [longitude]="longitude" [showMarker]="true"></app-leaflet-map>
          </div>
        </div>
        }
      </div>
    </div>
  </div>

  <div class="bg-[#C29667] pb-10 lg:pb-0 text-white">
    <div class="text-center lg:text-left lg:flex items-center xl:mx-40 lg:py-10 lg:px-20 gap-10">
      <img [src]="workshop?.organizerFirstPhoto" class="p-10 lg:p-0 lg:w-60 lg:h-60 lg:rounded-lg" alt="commerce image" />
      <div>
        <p class="text-lg mx-4 lg:text-2xl">Vous souhaitez en savoir plus sur {{workshop?.organizer?.merchant_name}} ?</p>
        <p class="text-sm my-5 mx-4">
          Vous pouvez visiter la page profil de ce commerçant,
          vous pourrez ainsi voir les autres offres qu’il propose.
          Que ce soit d’autres ateliers ou même des produits du terroir qu’il produit et commercialise...
        </p>
        <app-button class="text-xs" [buttonText]="'Visiter la page profil de ce commerçant'"></app-button>
      </div>
    </div>
  </div>

  <div class="mx-5 mt-10 mb-14 xl:mx-40">
    <div class="flex items-center justify-between">
      <div class="flex items-center gap-3">
        <i class="fa-solid fa-comment text-xl lg:text-3xl"></i>
        <p class="text-lg lg:text-2xl">Avis et commentaires</p>
      </div>
      <app-button (buttonClick)="openReview()" class="text-xs" [buttonText]="icon"></app-button>
    </div>

    <!-- Container for reviews -->
    <div class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-4 gap-4 mt-10 lg:flex justify-center">
      @for(review of workshop?.reviews.slice(0, displayedReviewsCount); track review){
      <div class="p-4 shadow-lg rounded bg-white">
        <div class="flex items-center gap-4 mt-4">
          <img [src]="review.user.avatar" alt="avatar" class="rounded-full h-14 w-14 aspect-square object-cover" />
          <div>
            <p>{{review.user.user_name}}</p>
            <app-star-rating [rating]="review.rating"></app-star-rating>
            <p>{{ review.review_date | date: 'dd/MM/yyyy' }}</p>
          </div>
        </div>
        <p class="mt-4">{{ review.content }}</p>
      </div>
      }
    </div>

    @if(workshop?.reviews.length > displayedReviewsCount){
    <div class="flex justify-center mt-4">
      <app-button (buttonClick)="showMoreReviews()" [buttonText]="'Afficher plus'"></app-button>
    </div>
    }
  </div>
</div>

<app-gallery [isOpen]="isGalleryOpen" [images]="photoUrls" (closeGallery)="isGalleryOpen = false"></app-gallery>

<app-modal [isOpen]="isReviewOpen" [title]="'Ajouter un commentaire'" (closed)="closeReview()">
  <div>
    <form [formGroup]="reviewForm">
      <div class="mb-4">
        <label for="rating" class="block text-gray-700 text-sm font-bold mb-2">Note:</label>
        <app-star-rating [rating]="reviewForm.controls['rating'].value" [editable]="true"
          (ratingChange)="reviewForm.controls['rating'].setValue($event)"></app-star-rating>
      </div>
      <div class="mb-4">
        <label for="content" class="block text-gray-700 text-sm font-bold mb-2">Commentaire:</label>
        <textarea id="content" formControlName="content" required
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"></textarea>
      </div>
      <div class="flex items-center justify-between">
        <button type="submit" (click)="submitReview()"
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          [disabled]="reviewForm.invalid">
          Ajouter
        </button>
      </div>
    </form>
  </div>
</app-modal>

<app-spinner [loading]="isLoading"></app-spinner>

<app-reservation [reservation_name]="workshop?.workshop_name" [reservationList]="workshop?.reservationDates"
  [isOpen]="isReservationOpen" (closeReservation)="isReservationOpen = false"></app-reservation>